/****************************************************************************
** Form implementation generated from reading ui file 'spView.ui'
**
** Created: Tue Feb 27 06:38:13 2001
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "spview.h"
#include "spectrum.h"
#include "pkelmer.h"

#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qstring.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qcursor.h>
#include <qmainwindow.h>
#include <qstatusbar.h>


/* 
 *  Constructs a spView which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 */
spView::spView( QWidget* parent,  const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "spView" );
    resize( 600, 480 ); 
    setCaption( tr( "Spectra View"  ) );
    setBackgroundOrigin( QWidget::ParentOrigin );
    QPalette pal;
    QColorGroup cg;
    cg.setColor( QColorGroup::Foreground, black );
    cg.setColor( QColorGroup::Button, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Light, white );
    cg.setColor( QColorGroup::Midlight, QColor( 233, 233, 233) );
    cg.setColor( QColorGroup::Dark, QColor( 105, 105, 105) );
    cg.setColor( QColorGroup::Mid, QColor( 140, 140, 140) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, white );
    cg.setColor( QColorGroup::ButtonText, black );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, white );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 0, 0, 128) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setActive( cg );
    cg.setColor( QColorGroup::Foreground, black );
    cg.setColor( QColorGroup::Button, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Light, white );
    cg.setColor( QColorGroup::Midlight, QColor( 242, 242, 242) );
    cg.setColor( QColorGroup::Dark, QColor( 105, 105, 105) );
    cg.setColor( QColorGroup::Mid, QColor( 140, 140, 140) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, white );
    cg.setColor( QColorGroup::ButtonText, black );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, white );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 0, 0, 128) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setInactive( cg );
    cg.setColor( QColorGroup::Foreground, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Button, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Light, white );
    cg.setColor( QColorGroup::Midlight, QColor( 242, 242, 242) );
    cg.setColor( QColorGroup::Dark, QColor( 105, 105, 105) );
    cg.setColor( QColorGroup::Mid, QColor( 140, 140, 140) );
    cg.setColor( QColorGroup::Text, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::BrightText, white );
    cg.setColor( QColorGroup::ButtonText, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, white );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 0, 0, 128) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setDisabled( cg );
    setPalette( pal );
     
    setMouseTracking(TRUE);
    setCursor( crossCursor );

    // signals and slots connections
}

/*  
 *  Destroys the object and frees any allocated resources
 */
spView::~spView()
{
    if(spectra)
     delete spectra;
}

void spView::load(QString fname)
{
  spectra = new SPFile(fname);
  spectra->Load(fname);
  spectra->ProcessSpectrum();
  SetupDisplay();
  plotSpectra();
  
}

void spView::SetupDisplay()
{
 int incremento, i, ft;
 QString stTemp;
 QPainter p( spectra->graph );
 
 setCaption( spectra->Afname ); 

 stTemp = tr("TRANSMITANCE %");
 p.drawRect( 50, 50, 547, 300 );
 p.setFont ( QFont( "times",  12 ) );
 p.drawText(50, 10, tr("Origin: ") + spectra->Origin);
 p.drawText(50, 21, tr("Title : ") + spectra->Afname);
 p.drawText(50, 32, tr("Created:") + spectra->Created); 
  
 incremento = 3600;
 ft = ((3600 - spectra->firstx)/10);
 i = 50;
 while(i < 547)
  {
   p.moveTo( i, 350);
   p.lineTo( i, 355);
   stTemp.setNum(incremento);
   p.drawText( i, 365, stTemp);
   i += 55;
   incremento -= ft; 
  } 


}

void spView::paintEvent(QPaintEvent* e)
{

QPainter p( this );
p.drawPixmap( 0, 0, *spectra->graph );
}

void spView::plotSpectra()
{
  int i, k, diff;
  
  QPainter p( spectra->graph );
  p.setPen( QColor(255, 0, 0) );

  for(i = 0;i<spectra->xValues.count();i++)
    {
    p.drawPoint(spectra->xValues[i].toInt() + 50, spectra->yValues[i].toInt());

    if(i != (spectra->yValues.count() - 1))
       {
       diff = spectra->yValues[i+1].toInt() - spectra->yValues[i].toInt();

       for(k=1;k<=abs(diff);k++)
         {
          if(diff<0)
            p.drawPoint(spectra->xValues[i].toInt() + 50,
                         spectra->yValues[i].toInt() - k); else
            p.drawPoint(spectra->xValues[i].toInt() + 50,
                         spectra->yValues[i].toInt() + k);

         }
       }

    }
  
}

// Mouse Moviments

void spView::mouseMoveEvent(QMouseEvent* e)
{
 
if( ((e->x() >= 50) && (e->x() <=  547)) )
 {
   
   QString msg("wave");
   for(int i=0;i<=spectra->xValues.count()-1;i++)
    {
     if((spectra->xValues[i].toInt() + 50) == e->x())
       {
         msg = "Wavelength: " + spectra->waveNumbers[i];
         break;
       }  
    } 
     
 }

}
